import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { IHistory } from 'src/app/models/server/history';

@Component({
  selector: 'tw-history-comment',
  templateUrl: './history-comment.component.html',
  styleUrls: ['./history-comment.component.scss'],
})
export class HistoryCommentComponent implements OnInit {
  @Input() comment: IHistory;
  @Input() skeleton = false;
  @Output() videoClick: EventEmitter<any> = new EventEmitter();
  @Output() imageClick: EventEmitter<any> = new EventEmitter();
  public showPhotoComments = false;

  constructor( ) { }

  ngOnInit() {
    setTimeout(() => {
      this.showPhotoComments = true;
    }, 3000);
   }

  playClicked(attachment) {
    this.videoClick.emit({
      commentId: this.comment.id,
      attachment
    });
  }

  imageClicked(attachment) {
    this.imageClick.emit(attachment);
  }

}
