import { Component, OnInit, Input } from '@angular/core';
import { PopoverController } from '@ionic/angular';

interface IpopoverMenuItem {
  text: string;
  icon: string;
}
@Component({
  selector: 'app-popover-menu',
  templateUrl: './popover-menu.component.html',
  styleUrls: ['./popover-menu.component.scss'],
})
export class PopoverMenuComponent implements OnInit {
  @Input() menu: IpopoverMenuItem[];
  public selectedOption;

  constructor(private popoverController: PopoverController) { }

  ngOnInit() {
  }

  selectOption(option: string) {
    this.selectedOption = option;
    this.dismissModal();
  }

  async dismissModal() {
    await this.popoverController.dismiss(this.selectedOption);
  }
}
