import { Subject } from 'rxjs';
import { OnDestroy } from '@angular/core';

export class Unsubscriber implements OnDestroy {
  protected _unsubscriber: Subject<any>;
  protected _isUnsubscribed: boolean;

  constructor() {
    this._unsubscriber = new Subject();
    this._isUnsubscribed = false;
  }

  ionViewWillUnload() {
    this._unsubscriber.next();
    this._unsubscriber.unsubscribe();
  }

  ngOnDestroy() {
    if (!this._isUnsubscribed ) {
      this.ionViewWillUnload();
    }
  }
}
