import {AfRole, Auth0User} from '../Server';

export class User implements Auth0User {
  username?: string;
  email?: string;
  first_name?: string;
  last_name?: string;
  token: string;
  email_verified?: boolean;
  user_id?: string;
  picture?: string;
  nickname?: string;
  identities?: any[];
  updated_at?: string;
  created_at?: string;
  name?: string;
  roles?: AfRole[];
  app_metadata?: any;
  last_ip?: any;
  last_login?: string;
  logins_count?: number;
  password?: string;
  specialty_id?: string;
  phone_number?: string;
  organizations?: any[];
  picture_document_id?: string;
  document_url?: string;

  constructor(userObj?: any, token?: string) {
    if (userObj && token) {
      const usr: User = userObj.user;
      this.token = token;
      this.username = usr.email;
      this.email = usr.email;
      this.name = usr.name;
      this.first_name = usr.first_name;
      this.last_name = usr.last_name;
      this.nickname = usr.nickname;
      this.user_id = usr.user_id;
      this.email_verified = usr.email_verified;
      this.picture = usr.picture;
      this.identities = usr.identities;
      this.updated_at = usr.updated_at;
      this.created_at = usr.created_at;
      this.app_metadata = usr.app_metadata;
      this.last_ip = usr.last_ip;
      this.last_login = usr.last_login;
      this.logins_count = usr.logins_count;
      this.specialty_id = usr.specialty_id;
      this.phone_number = usr.phone_number;
      this.picture_document_id = usr.picture_document_id;
      this.document_url = usr.document_url;

      this.organizations = userObj.organizations;
      this.roles = userObj.roles;
    }
  }

  hasRole(roleName: string): boolean {
    if (this.roles) {
      const lowercaseRoleName = roleName.toLowerCase();
      for (const role of this.roles) {
        if (role.name.toLowerCase() === lowercaseRoleName) {
          return true;
        }
      }
    }
    return false;
  }
}
