import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from 'src/environments/environment';
import { UserType } from '../models/server/UserType';

@Injectable({
  providedIn: 'root'
})
export class InvitationService {

  constructor(private http: HttpClient) { }

  getUserInvitation(userToken: string) {
    return this.http.get<any>(`${environment.API_URL}/api/invitation?userToken=${userToken}`);
  }

  finalizeInvitation(data: object) {
    return this.http.post<any>(`${environment.API_URL}/api/invitation/finalize`, data);
  }

  inviteUser(data) {
    data.userType = UserType.Guardian;
    return this.http.post<any>(`${environment.API_URL}/api/invitation/inviteuser`, data);
  }

  getSpecialties(userToken: string) {
    return this.http.get<any>(`${environment.API_URL}/api/invitation/specialties?userToken=${userToken}`);
  }

  addNewOrganization(data: any, userToken: string) {
    const submitData = Object.assign({type: 'SUGORG'}, data);
    return this.http.post<any>(`${environment.API_URL}/api/invitation/addorganization?userToken=${userToken}`, submitData);
  }

}
