export class SimpleQueue<T> {

  private _queue: T[] = [];
  private _activeItem: T = null;

  public processElement: (arg: T) => Promise<any> = () => new Promise((r) => r());

  constructor(elementProcessor?: (arg: T) => Promise<any>) {
    if (elementProcessor) {
      this.processElement = elementProcessor;
    }
  }

  public get rawQueue() {
    return this._queue;
  }

  public get currentItem() {
    return this._activeItem;
  }

  public enqueue(item: T) {
    this._queue.push(item);
    setTimeout(() => this.processQueue());
  }

  private processQueue() {
    if (this._activeItem || !this._queue.length) {
      return;
    }

    this._activeItem = this._queue.shift();

    if (this.processElement) {
      this.processElement.call(null, this._activeItem)
        .then(() => {
          this.completePass();
        })
        .catch(e => {
          console.error(e);
          this.completePass();
        });
    }
  }

  private completePass() {
    this._activeItem = null;
    setTimeout(() => this.processQueue());
  }
}
